/*
 * AppController.j
 * SimpleTableView
 *
 * Created by You on August 18, 2016.
 * Copyright 2016, Your Company All rights reserved.
 */

@import <Foundation/Foundation.j>
@import <AppKit/AppKit.j>


@implementation AppController : CPObject
{
    @outlet CPWindow    theWindow;
    @outlet CPTableView tableView;
    CPMutableArray      _names;
    @outlet CPTextField textField;
}

- (id)init
{
    if (self = [super init])
    {
        _names = @["Alpha", "Beta", "Charlie", "Delta"];
    }
    return self;
}

- (void)applicationDidFinishLaunching:(CPNotification)aNotification
{
    // This is called when the application is done loading.
}

- (void)awakeFromCib
{
    [theWindow setFullPlatformWindow:NO];
}

- (int)numberOfRowsInTableView:(CPTableView)aTableView
{
    return [_names count];
}

- (id)tableView:(CPTableView)aTableView objectValueForTableColumn:(CPTableColumn)aColumn row:(CPInteger)aRowIndex
{
    return [_names objectAtIndex:aRowIndex];
}

- (@action)addItem:(id)sender
{
    // Get CPTextField value and add to our CPMutableArray
    [_names addObject: [textField stringValue]];

    // Clear the CPTextField
    [textField setStringValue:""];

    // Reload CPTableView to see the changes
    [tableView reloadData];
}


- (@action)removeItem:(id)sender
{
    // Check if any row is selected; if not the value is -1.
    if ([tableView selectedRow] > -1)
    {
        [_names removeObject:[_names objectAtIndex:[tableView selectedRow]]];
    }

    // Reload CPTableView to see the changes.
    [tableView reloadData];
}

@end
